000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. CURSOR002.
000020 DATA DIVISION.
000030 WORKING-STORAGE SECTION.
000040 EXEC SQL BEGIN DECLARE SECTION END-EXEC.
000050 01 NAME PIC X(20).
000060 01 ADDR PIC X(100).
000070 EXEC SQL END DECLARE SECTION END-EXEC.
000080 PROCEDURE DIVISION.
000090 MAIN00.
000100     EXEC SQL
000110        WHENEVER SQLERROR GOTO :SQL-ERROR
000120     END-EXEC.
000130* 'TESTDB.sqlite3'への接続
000140     EXEC SQL 
000150        CONNECT TO 'TESTDB.sqlite3'
000160     END-EXEC.
000170* カーソルの宣言
000180     EXEC SQL
000190        DECLARE C1 CURSOR FOR
000200        SELECT name, address from address_book
000210               WHERE address LIKE '%東京%'
000220     END-EXEC.
000230* カーソルのオープン
000240     EXEC SQL
000250        OPEN C1
000260     END-EXEC.
000270* データの読み出し
000280     PERFORM FOREVER
000290        EXEC SQL
000300          FETCH C1 INTO :NAME, :ADDR     
000310        END-EXEC   
000320        IF SQLCODE = 100  *> AT END
000330           EXIT PERFORM
000340        END-IF
000350        DISPLAY FUNCTION TRIM(NAME) ":" FUNCTION TRIM(ADDR)
000360     END-PERFORM.
000370* カーソルのクローズ
000380     EXEC SQL
000390        CLOSE C1
000400     END-EXEC.
000410* データベース接続解除
000420     EXEC SQL
000430        DISCONNECT
000440     END-EXEC.
000450     STOP RUN.
000460 SQL-ERROR.
000470     DISPLAY "SQLCODE = " SQLCODE.
000480     DISPLAY "SQLMSG=   " SQLMSG.
000490     DISPLAY "SQLIMAGE= " SQLIMAGE.
000500     STOP RUN.