000000 identification division.
000010 program-id. sample001.
000020 data division.
000030 working-storage section.
000040 01 init-value.
000050    02  pic N(30) value 
000060        NC"旧岩崎邸庭園／旧芝離宮恩賜庭園／／井の頭公園" &
000070        NC"＊＊＊＊＊＊＊＊".
000080    02  pic N(10) value space.
000090    02  pic N(10) value space.
000100    02  pic N(10) value space.
000110    02  pic NN    value space.
000120    02  pic NN    value space.
000130    02  pic NN    value space.
000140    02  pic 99    value zero.
000150    02  pic 99    value zero.
000160    02  pic 99    value zero.
000170    02  pic 99    value 1.
000180    02  pic 99    value 0.
000190 01 work.
000200    02 send-a pic N(30).
000210    02 rcv-1  pic N(10).
000220    02 rcv-2  pic N(10).
000230    02 rcv-3  pic N(10).
000240    02 del-1  pic NN.
000250    02 del-2  pic NN.
000260    02 del-3  pic NN.
000270    02 ctr-1  pic 99.
000280    02 ctr-2  pic 99.
000290    02 ctr-3  pic 99.
000300    02 ptr-a  pic 99.
000310    02 tall-a pic 99.
000320 procedure division.
000330 main00.
000340     move init-value to work.
000350*    send-aの値を、rcv-1, rcv-2, rcv-3に転記
000360     unstring send-a
000370         into rcv-1 rcv-2 rcv-3
000380         with pointer ptr-a.
000390     if rcv-1 = NC"旧岩崎邸庭園／旧芝離" and
000400        rcv-2 = NC"宮恩賜庭園／／井の頭" and
000410        rcv-3 = NC"公園＊＊＊＊＊＊＊＊"
000420         display "001 OK"
000430     else
000440         display "001 NG"
000450         display "   rcv-1:[" rcv-1 "]"
000460         display "   rcv-2:[" rcv-2 "]"
000470         display "   rcv-3:[" rcv-3 "]"
000480     end-if
000490*
000500     move init-value to work.
000510*    区切り文字としてNC"／"を指定して、send-aの値を rcv-1, rcv-2
000520*    rcv-3に転記
000530     UNSTRING SEND-A
000540       DELIMITED BY NC"／"
000550       INTO RCV-1 COUNT IN CTR-1
000560            RCV-2 COUNT IN CTR-2
000570            RCV-3 COUNT IN CTR-3
000580       WITH POINTER PTR-A TALLYING IN TALL-A. 
000590     if rcv-1 = NC"旧岩崎邸庭園　　　　" and
000600        rcv-2 = NC"旧芝離宮恩賜庭園　　" and
000610        rcv-3 = NC"　　　　　　　　　　" and 
000620        ctr-1 = 6    and
000630        ctr-2 = 8    and
000640        ctr-3 = 0    and
000650        ptr-a = 18 and tall-a = 3
000660         display "002 OK"
000670     else
000680         display "002 NG"
000690         display "  rcv-1:[" rcv-1 "]"
000700         display "  rcv-2:[" rcv-2 "]"
000710         display "  rcv-3:[" rcv-3 "]"
000720         display "  ptr-a:" ptr-a
000730         display "  tall-a:" tall-a
000740     end-if.
000750*
000760     move init-value to work.
000770     move 5 to tall-a.
000780*    区切り文字を、ALL指定のNC"／"とNC"＊"にして、send-aの値を
000790*    rcv-1, rcv-2, rcv-3に転記
000800     UNSTRING SEND-A
000810       DELIMITED BY ALL NC"／" OR ALL NC"＊"
000820       INTO RCV-1 DELIMITER IN DEL-1
000830                  COUNT IN CTR-1
000840            RCV-2 DELIMITER IN DEL-2
000850                  COUNT IN CTR-2
000860            RCV-3 DELIMITER IN DEL-3
000870                  COUNT IN CTR-3
000880       WITH POINTER PTR-A TALLYING IN TALL-A. 
000890     if rcv-1 = NC"旧岩崎邸庭園　　　　" and
000900        rcv-2 = NC"旧芝離宮恩賜庭園　　" and
000910        rcv-3 = NC"井の頭公園　　　　　" and 
000920        del-1 = NC"／" and
000930        del-2 = NC"／" and
000940        del-3 = NC"＊" and
000950        ctr-1 = 6    and
000960        ctr-2 = 8    and
000970        ctr-3 = 5    and
000980        ptr-a = 31 and tall-a = 8
000990         display "003 OK"
001000     else
001010         display "003 NG"
001020         display "  rcv-1:[" rcv-1 "]"
001030         display "  rcv-2:[" rcv-2 "]"
001040         display "  rcv-3:[" rcv-3 "]"
001050         display "  del-1:[" del-1 "]"
001060         display "  del-2:[" del-2 "]"
001070         display "  del-3:[" del-3 "]"
001080         display "  ctr-1: " ctr-1
001090         display "  ctr-2: " ctr-2
001100         display "  ctr-3: " ctr-3
001110         display "  ptr-a:" ptr-a
001120         display "  tall-a:" tall-a
001130     end-if.
001140* Overflow Test
001150     move init-value to work.
001160     unstring send-a
001170         into rcv-1 rcv-2 rcv-3
001180         with pointer ptr-a
001190     on overflow
001200         display "004 NG"
001210     not overflow
001220         display "004 OK"
001230     end-unstring.
001240*
001250     move init-value to work.
001260     UNSTRING SEND-A
001270       DELIMITED BY NC"／"
001280       INTO RCV-1 COUNT IN CTR-1
001290            RCV-2 COUNT IN CTR-2
001300            RCV-3 COUNT IN CTR-3
001310       WITH POINTER PTR-A TALLYING IN TALL-A
001320     on overflow
001330         display "005 OK"
001340     not overflow
001350         display "005 NG"
001360     end-unstring.
001370*
001380     move init-value to work.
001390     UNSTRING SEND-A
001400       DELIMITED BY ALL NC"／" OR ALL NC"＊"
001410       INTO RCV-1 DELIMITER IN DEL-1
001420                  COUNT IN CTR-1
001430            RCV-2 DELIMITER IN DEL-2
001440                  COUNT IN CTR-2
001450            RCV-3 DELIMITER IN DEL-3
001460                  COUNT IN CTR-3
001470       WITH POINTER PTR-A TALLYING IN TALL-A
001480     on overflow
001490         display "006 NG"
001500     not overflow
001510         display "006 OK"
001520     end-unstring.
001530*
001540     move 1000 to ptr-a.
001550     UNSTRING SEND-A
001560       DELIMITED BY ALL NC"／" OR ALL NC"＊"
001570       INTO RCV-1 DELIMITER IN DEL-1
001580                  COUNT IN CTR-1
001590       WITH POINTER PTR-A TALLYING IN TALL-A
001600     on overflow
001610         display "007 OK"
001620     not overflow
001630         display "007 NG"
001640     end-unstring.