000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. SAMPLE001.
000020 DATA DIVISION.
000030 WORKING-STORAGE SECTION.
000040 01 A.
000050    02 I PIC 9(5) VALUE 3.
000060    02 J PIC 9(5) VALUE 100.
000070    02 K PIC 9(10).
000080    02 m1 pic x(30).
000090 01 random-val pic S9(2)V9(8).
000100 01 today pic 9(6).
000110 PROCEDURE DIVISION.
000120 MAIN00.
000130*MAX
000140     if function max("AAA" "bbb" function upper-case("ccc") ) =
000150        "bbb"
000160        display "MAX-001 OK" else display "MAX-001 NG".
000170     if function max(1 2) = 2
000180        display "MAX-002 OK" else display "MAX-001 NG".
000190     if function max(1 2 function max(10 + 5 2 + 3 4 + 6)*2) = 30
000200        display "MAX-003 OK" else display "MAX-001 NG".
000210*MIN
000220     if function min(1 2) = 1
000230        display "MIN-001: OK"
000240     else
000250        display "MIN-001: NG".
000260*INTEGER
000270     if function integer(+1.5) = +1
000280        display "INT-001: OK"
000290     else
000300        display "INT-001: NG".
000310     if function integer(-1.5) = -2
000320        display "INT-002: OK"
000330     else
000340        display "INT-002: NG".
000350*MOD
000360     if function mod(11 5) = 1
000370        display "MOD-001: OK"
000380     else
000390        display "MOD-001: NG " function mod(11 5).
000400     if function mod(-11 5) = 4
000410        display "MOD-001: OK"
000420     else
000430        display "MOD-001: NG " function mod(-11 5).
000440     if function mod(11 -5) = -4
000450        display "MOD-001: OK"
000460     else
000470        display "MOD-001: NG " function mod(11 -5).
000480     if function mod(-11 -5) = -1
000490        display "MOD-001: OK"
000500     else
000510        display "MOD-001: NG " function mod(-11 -5).
000520*INTEGER-PART
000530     if function integer-part(+1.5) = +1
000540        display "INT-PART-001: OK"
000550     else
000560        display "INT-PART-001: NG".
000570     if function integer-part(-1.5) = -1
000580        display "INT-PART-002: OK"
000590     else
000600        display "INT-PART-002: NG".
000610*REM
000620     if function rem(11 5) = 1
000630        display "REM-001: OK"
000640     else
000650        display "REM-001: NG " function rem(11 5).
000660     if function rem(-11 5) = -1
000670        display "REM-001: OK"
000680     else
000690        display "REM-001: NG " function rem(-11 5).
000700     if function rem(11 -5) = 1
000710        display "REM-001: OK"
000720     else
000730        display "REM-001: NG " function rem(11 -5).
000740     if function rem(-11 -5) = -1
000750        display "REM-001: OK"
000760     else
000770        display "REM-001: NG " function rem(-11 -5).
000780* RANGE
000790     if function range(1 2 5 9) = 8
000800        display "RANGE-001 OK"
000810     else
000820        display "RANGE-001 NG " function range(1 2 5 9).
000830     if function range(100.3 10+10 200.6+10 5 ** 3) = 190.6
000840        display "RANGE-001 OK"
000850     else
000860        display "RANGE-001 NG " function range(100.3 10+10 
000870                 200.6+10 5 ** 3).
000880* REVERSE
000890     if function reverse("ABCDEFG") = "GFEDCBA"
000900        display "REVERSE-001 OK"
000910     else
000920        display "RECERSE-001 NG " function reverse("ABCDEFG").
000930* LOWER-CASE
000940     if function lower-case("123ABCxyzあいう") = "123abcxyzあいう"
000950        display "LOWER-001 OK"
000960     else
000970        display "LOWER-001 NG " function 
000980                                lower-case("123ABCxyzあいう").    
000990* UPPER-CASE
001000     if function upper-case("123abcXYZあいう") = "123ABCXYZあいう"
001010        display "UPPER-001 OK"
001020     else
001030        display "UPPER-001 NG " function 
001040                                upper-case("123abcXYZあいう").
001050* LENGTH
001060     if function length(m1 of a) = 30
001070        display "LENGTH-001 OK"
001080     else
001090        display "LENGTH-001 NG " function length(m1 of a).
001100     if function length(a) = 50
001110        display "LENGTH-002 OK"
001120     else
001130        display "LENGTH-002 NG " function length(a).
001140     if function length("abcdefg") = 7
001150        display "LENGTH-003 OK"
001160     else
001170        display "LENGTH-003 NG " function length("abcdefg").
001180     if function length(000123) = 3
001190        display "LENGTH-004 OK"
001200     else
001210        display "LENGTH-004 NG " function length(000123).
001220     if function length(999 + 1) = 4
001230        display "LENGTH-005 OK"
001240     else
001250        display "LENGTH-005 NG " function length(999 + 1).
001260*ORD                                     
001270     if function ord("A") = 65
001280        display "ORD-001 OK"
001290     else
001300        display "ORD-001 NG " function ord("A").
001310*ORD-MAX        
001320     if function ord-max(15 20 9 19 16) = 2
001330        display "ORD-MAX-001 OK"
001340     else
001350        display "ORD-MAX-001 NG " function ord-max(15 20 9 19 16).
001360*ORD-MIN        
001370     if function ord-min(15 20 9 19 16) = 3
001380        display "ORD-MIN-001 OK"
001390     else
001400        display "ORD-MIN-001 NG " function ord-min(15 20 9 19 16).
001410*RANDOM
001420     perform 5 times
001430        display "random(not seed):" function random
001440     end-perform.
001450     compute random-val = function random(1).
001460     perform 5 times
001470        display "random(seed: 1回目):" function random
001480     end-perform.
001490     compute random-val = function random(1).
001500     perform 5 times
001510        display "random(seed: 2回目):" function random
001520     end-perform.
001530*FACTORIAL
001540     if function factorial(1) = 1
001550        display "FACTORIAL-001 OK"
001560     else
001570        display "FACTORIAL-001 NG " function factorial(0).
001580     if function factorial(5) = 120
001590        display "FACTORIAL-002 OK"
001600     else
001610        display "FACTORIAL-002 NG " function factorial(5).
001620*LOG       
001630     if function log(2.0) = 0.6931471805599453094172321215
001640        display "LOG-001 OK"
001650     else
001660        display "LOG-001 NG " function log(2).        
001670*LOG10       
001680     if function log10(1000) = 3.0
001690        display "LOG10-001 OK"
001700     else
001710        display "LOG10-001 NG " function log10(1000). 
001720        
001730*MEAN       
001740     if function MEAN(1 2 3 4 5) = 3
001750        display "MEAN-001 OK"
001760     else
001770        display "MEAN-001 NG " function MEAN(1 2 3 4 5). 
001780*MEDIAN       
001790     if function MEDIAN(2 2 3 4 5 5 5 5) = 4.5
001800        display "MEDIAN-001 OK"
001810     else
001820        display "MEDIAN-001 NG " function MEDIAN(2 2 3 4 5 5 5 5). 
001830*MIDRANGE      
001840     if function MIDRANGE(5 3 1 2 4) = 3.0
001850        display "MIDRANGE-001 OK"
001860     else
001870        display "MIDRANGE-001 NG " function MIDRANGE(5 3 1 2 4). 
001880*SQRT       
001890     if function SQRT(16) = 4
001900        display "SQRT-001 OK"
001910     else
001920        display "SQRT-001 NG " function SQRT(16). 
001930*CURRENT-DATE        
001940     display "CURRENT-DATE:" function CURRENT-DATE
001950     display "CURRENT-DATE: yyyy =" function CURRENT-DATE(1:4)
001960     display "CURRENT-DATE: mm =" function CURRENT-DATE(5:2)
001970     if function current-date(1:4) = "2024"
001980        display "CURRENT-DATE-001 OK"
001990     else
002000        display "CURRENT-DATE-001 NG " function current-date
002010           (1:4).
002020*DATE-OF-INTEGER.
002030     if function date-of-integer(160001) = 20390125
002040        display "DATE-OF-INTEGER-001 OK"
002050     else
002060        display "DATE-OF-INTEGER-001 NG " function
002070                                      date-of-integer(160001).
002080*INTEGER-OF-DATE     
002090     if function integer-of-date(20390125) = 160001
002100        display "INTEGER-OF-DATE-001 OK"
002110     else
002120        display "INTEGER-OF-DATE-001 NG " function
002130                                      integer-of-date(20390125).
002140*
002150     accept today from date.
002160     display "明日の日付は" function date-of-integer(
002170        function integer-of-date(today + 20000000) + 1).
002180*INTEGER-OF-DAY     
002190     if function integer-of-day(2039025) = 160001 
002200        display "INTEGER-OF-DAY-001 OK"
002210     else
002220        display "INTEGER-OF-DAY-001 NG " function
002230                                      integer-of-day(2039056).
002240*NUMVAL    
002250     if function numval (" - 12.345  ") = -12.345
002260        display "NUMVAL-001 OK"
002270     else
002280        display "NUMVAL-001 NG " function numval(" - 12.345  ").
002290     if function numval ("12.345 DB") = -12.345
002300        display "NUMVAL-002 OK"
002310     else
002320        display "NUMVAL-002 NG " function numval("12.345 DB").
002330*NUMVAL-C    
002340     if function numval-c (" - \12.345") = -12.345
002350        display "NUMVAL-C-001 OK"
002360     else
002370        display "NUMVAL-C-001 NG " function 
002380                                      numval-c(" - \12.345").
002390     if function numval-c ("$12.345 DB", "$") = -12.345
002400        display "NUMVAL-C-002 OK"
002410     else
002420        display "NUMVAL-C-002 NG " function numval-c
002430                                      ("$12.345 DB", "$").
002440     if function numval-c ("\123,000.345") = 123000.345
002450        display "NUMVAL-C-003 OK"
002460     else
002470        display "NUMVAL-C-003 NG " function 
002480                                       numval-c ("\123,000.345").
002490     IF FUNCTION NUMVAL-C ("\1,234.56") = 1234.56
002500         DISPLAY "NUMVAL-C-004 OK"
002510     ELSE
002520         DISPLAY "NUMVAL-C-004 NG"
002530         DISPLAY "FUNCTION NUMVAL-C (\1,234.56) = " 
002540         FUNCTION NUMVAL-C ("¥1,234.56")
002550     END-IF.
002560*ACOS
002570    if function acos(-1) = 3.141592653589793
002580        display "ACOS-001 OK"
002590     else
002600        display "ACOS-001 NG " function acos(-1).
002610*ASIN
002620    if function asin(-1) = -1.5707963267948966
002630        display "ASIN-001 OK"
002640     else
002650        display "ASIN-001 NG " function asin(-1).
002660*ATAN
002670     if function atan(1) = 0.7853981633974483
002680        display "ATAN-001 OK"
002690     else
002700        display "ATAN-001 NG " function atan(1).
002710        
002720*CHAR
002730     if function char(65) = "A"
002740        display "CHAR-001 OK"
002750     else
002760        display "CHAR-001 NG " function char(65).
002770        
002780*COS
002790     if function cos(0) = 1
002800        display "COS-001 OK"
002810     else
002820        display "COS-001 NG " function cos(0). 
002830*SIN
002840     if function SIN(0) = 0
002850        display "COS-001 OK"
002860     else
002870        display "COS-001 NG " function sin(0).
002880*TAN
002890     if function TAN(0) = 0
002900        display "TAN-001 OK"
002910     else
002920        display "TAN-001 NG " function tan(0).
002930*ANNUITY
002940     if function annuity(0, 2) = 0.5
002950        display "ANNUITY-001 OK"
002960     else
002970        display "ANNUITY-001 NG " function annuity(0 2).
002980     if function annuity(0.1, 2) = 0.5761904761904759
002990        display "ANNUITY-001 OK"
003000     else
003010        display "ANNUITY-001 NG " function annuity(0.1 2).
003020*PRESENT-VALUE
003030     if function present-value(0.05, 100) = 95.23809523809524
003040        display "PRESENT-VALUE-001 OK"
003050     else
003060        display "PRESENT-VALUE-001 NG " function present-value
003070                       (0.05, 100).
003080*VARIANCE
003090     if function variance(2 4 4 4 5 5 7 9) = 4.0
003100        display "VARIANCE-001 OK"
003110     else
003120        display "VARIANCE-001 NG " function variance
003130                    (2 4 4 4 5 5 7 9).
003140     if function variance(5 5 5 5 5) = 0
003150        display "VARIANCE-002 OK"
003160     else
003170        display "VARIANCE-002 NG " function variance
003180                    (5 5 5 5 5).
003190*STANDARD-DEVIATION
003200     if function standard-deviation(2, 4, 4, 4, 5, 5, 7, 9) = 2.0
003210        display "STANDARD-DEV-001 OK"
003220     else
003230        display "STANDARD-DEV-001 NG " function standard-deviation
003240              (2, 4, 4, 4, 5, 5, 7, 9).
003250     if function standard-deviation(5 5 5 5 5) = 0
003260        display "STANDARD-DEV-002 OK"
003270     else
003280        display "STANDARD-DEV-002 NG " function standard-deviation
003290              (5 5 5 5 5).
003300     display "WHEN-COMPILED: " function when-compiled.
003310     display "WHEN-COMPILED: YYYY " function when-compiled(1:4).
003320*TRIM
003330     if function trim("   ABC  ") = "ABC"
003340        display "TRIM-001 OK"
003350     else
003360        display "TRIM-001 NG".  
003370     if function trim(NC"　　日本　　") = NC"日本"
003380        display "TRIM-002 OK"
003390     else
003400        display "TRIM-002 NG"
003410        display "function trim(NC'　　日本　　') = '" 
003420              function trim(NC"　　日本　　") "'".
003430     if function trim("   ABC   ", LEADING) = "ABC   "
003440        display "TRIM-003 OK"
003450     else
003460        display "TRIM-003 NG".
003470     if function trim(NC"　　日本　　", TRAILING) = NC"　　日本"
003480        display "TRIM-004 OK"
003490     else
003500        display "TRIM-004 NG".
003510     if function trim(NC"　　日本　　", TRAILING, LEADING) 
003520                     = NC"日本"
003530        display "TRIM-005 OK"
003540     else
003550        display "TRIM-005 NG".
003560     
003570     STOP RUN.