000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. SEQFILE003.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 果物ファイル ASSIGN TO "./果物ファイル.txt".
000060 DATA DIVISION.
000070 FILE SECTION.
000080 FD 果物ファイル.
000090 01 果物レコード.
000100    02 名前 PIC N(10).
000110    02 数量 PIC 9(5).
000120 WORKING-STORAGE SECTION.
000130 01 ヘッダ.
000140    02          PIC N(10) VALUE NC"果物名".
000150    02          PIC N(3)  VALUE NC"個数".
000160 01 罫線        PIC X(25) VALUE ALL "-".
000170 01 果物データ.
000180    02 果物名   PIC N(10).
000190    02 個数     PIC ZZZZ9.
000200 01 合計データ.
000210    02          PIC N(10) VALUE NC"合計".
000220    02 合計     PIC ZZZZ9.
000230 PROCEDURE DIVISION.
000240 MAIN00.
000250*    ファイルのオープン
000260     OPEN I-O 果物ファイル.
000270*    ファイルから果物データをAT ENDとなるまで読み込む
000280     PERFORM FOREVER
000290         READ 果物ファイル
000300         AT END
000310           EXIT PERFORM
000320         END-READ
000330         IF 名前 OF 果物レコード = NC"オレンジ"
000340           MOVE 15 TO 数量 OF 果物レコード
000350           REWRITE 果物レコード
000360         END-IF
000370         IF 名前 OF 果物レコード = NC"バナナ"
000380           DELETE 果物ファイル
000390         END-IF
000400     END-PERFORM.
000410     
000420*    ファイルのクローズ
000430     CLOSE 果物ファイル.
000440     
000450*    再オープン
000460     OPEN INPUT 果物ファイル.
000470     
000480*    初期化
000490     MOVE 0 TO 合計.
000500*    ヘッダ出力
000510     DISPLAY ヘッダ.
000520     DISPLAY 罫線.
000530*    ファイルから果物データをAT ENDとなるまで読み込む
000540     PERFORM FOREVER
000550         READ 果物ファイル
000560         AT END
000570           EXIT PERFORM
000580         NOT AT END
000590           MOVE 名前 OF 果物レコード TO 果物名
000600           MOVE 数量 OF 果物レコード TO 個数
000610           DISPLAY 果物データ
000620           ADD  数量 OF 果物レコード TO 合計
000630         END-READ
000640     END-PERFORM.
000650*    フッタの出力
000660     DISPLAY 罫線.
000670     DISPLAY 合計データ.
000680*    ファイルのクローズ
000690     CLOSE 果物ファイル.
000700     STOP RUN.