000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. CURSOR001.
000020 DATA DIVISION.
000030 WORKING-STORAGE SECTION.
000040 EXEC SQL BEGIN DECLARE SECTION END-EXEC.
000050 01 NAME PIC X(20).
000060 01 ADDR PIC X(100).
000070 EXEC SQL END DECLARE SECTION END-EXEC.
000080 PROCEDURE DIVISION.
000090 MAIN00.
000100     EXEC SQL
000110        WHENEVER SQLERROR GOTO :SQL-ERROR
000120     END-EXEC.
000130* 'TESTDB.sqlite3'への接続
000140     EXEC SQL 
000150        CONNECT TO 'TESTDB.sqlite3'
000160     END-EXEC.
000170* カーソルの宣言
000180     EXEC SQL
000190        DECLARE C1 CURSOR FOR
000200        SELECT name, address from address_book
000210     END-EXEC.
000220* カーソルのオープン
000230     EXEC SQL
000240        OPEN C1
000250     END-EXEC.
000260* データの読み出し
000270     PERFORM FOREVER
000280        EXEC SQL
000290          FETCH C1 INTO :NAME, :ADDR     
000300        END-EXEC   
000310        IF SQLCODE = 100  *> AT END
000320           EXIT PERFORM
000330        END-IF
000340        DISPLAY FUNCTION TRIM(NAME) ":" FUNCTION TRIM(ADDR)
000350     END-PERFORM.
000360* カーソルのクローズ
000370     EXEC SQL
000380        CLOSE C1
000390     END-EXEC.
000400* データベース接続解除
000410     EXEC SQL
000420        DISCONNECT
000430     END-EXEC.
000440     STOP RUN.
000450 SQL-ERROR.
000460     DISPLAY "SQLCODE = " SQLCODE.
000470     DISPLAY "SQLMSG=   " SQLMSG.
000480     DISPLAY "SQLIMAGE= " SQLIMAGE.
000490     STOP RUN.