000000 IDENTIFICATION DIVISION.
000010 PROGRAM-ID. INDFILE002.
000020 ENVIRONMENT DIVISION.
000030 INPUT-OUTPUT SECTION.
000040 FILE-CONTROL.
000050     SELECT 果物ファイル ASSIGN TO "./果物ファイル.sqlite3"
000060            ORGANIZATION IS INDEXED
000070            RECORD KEY IS 商品番号 OF 果物レコード
000080            ACCESS MODE IS DYNAMIC.
000090 DATA DIVISION.
000100 FILE SECTION.
000110 FD 果物ファイル.
000120 01 果物レコード.
000130    02 商品番号 PIC 9(3).
000140    02 名前     PIC N(10).
000150    02 数量     PIC 9(5).
000160 PROCEDURE DIVISION.
000170 MAIN00.
000180*    ファイルのオープン
000190     OPEN I-O 果物ファイル.
000200*    主キー(商品番号)に102を設定してオレンジレコードを読む
000210     MOVE 102 TO 商品番号 OF 果物レコード.
000220     READ 果物ファイル
000230     INVALID
000240        DISPLAY "READ: オレンジレコードが見つからない"
000250        STOP RUN
000260     END-READ.
000270*    数量を15にして更新する。
000280     MOVE 15 TO 数量 OF 果物レコード.
000290     REWRITE 果物レコード
000300     INVALID
000310        DISPLAY "REWRITE: オレンジレコードの更新に失敗"
000320        STOP RUN
000330     END-REWRITE.
000340*    主キー(商品番号)に104を設定してバナナレコードを読む
000350     MOVE 104 TO 商品番号 OF 果物レコード.
000360     DELETE 果物ファイル
000370     INVALID
000380        DISPLAY "DELETE: バナナレコードの削除に失敗"
000390        STOP RUN
000400     END-DELETE.
000410*    ファイルのクローズ
000420     CLOSE 果物ファイル.
000430     STOP RUN.